'Generated by PowerPCB's VB Script Wizard -customized by Ron Olinyk 28.11.01
'Creates report in Excel Format of routed net length.
'Select net(s) then run script
' if no nets selected, all nets in design are reported.

'Array of column names. You can modify it to rename columns
Const Columns = Array("Name", "Routed Length")
Dim fname As String

Sub Main
    Dim net_cnt
	fname = ActiveDocument
	If fname = "" Then
		fname = "Untitled"
	End If
	tempFile = DefaultFilePath & "\temp.txt"
	Open tempFile For Output As #1

	StatusBarText = "Generating report..."
	'Output table header
	For i = 0 to UBound(Columns)
		OutCell Columns(i)
	Next
	Print #1
	'Output table rows
	Set nobj = ActiveDocument.GetObjects(ppcbObjectTypeNet,,True)
	If nobj.Count < 1 Then
	  For Each aNet In ActiveDocument.Nets
		OutCell aNet.Name
		OutCell Format(aNet.Length(True), "0.00")
		Print #1
	  Next aNet
	Else
	  For Each aNet In nobj
		OutCell aNet.Name
		OutCell Format(aNet.Length(True), "0.00")
		Print #1
	  Next aNet
	End If

	StatusBarText = ""
	Close #1
	ExportToExcel
End Sub

Sub ExportToExcel
    FillClipboard
	Dim xl As Object
	On Error Resume Next
	Set xl =  GetObject(,"Excel.Application")
	On Error GoTo ExcelError	' Enable error trapping.
	If xl Is Nothing Then
		Set xl =  CreateObject("Excel.Application")
	End If
	xl.Visible = True
	xl.Workbooks.Add
	xl.ActiveSheet.Paste
	xl.Range("A1:B1").Font.Bold = True
	xl.Range("A1:B1").NumberFormat = "@"
	'xl.Range("A1:B1").AutoFilter
	xl.ActiveSheet.UsedRange.Columns.AutoFit
	'Output Report Header
	xl.Rows(1).Insert
	xl.Rows(1).Cells(1) = Space(1) & "Net Report for " & fname & " on " & Now & "  Units:" & Unit_fncn()
	xl.Rows(2).Insert
	xl.Rows(1).Font.bold = True
	xl.Range("A1").Select
	On Error GoTo 0 ' Disable error trapping. 
	Exit Sub    

ExcelError:
	MsgBox Err.Description, vbExclamation, "Error Running Excel"
	On Error GoTo 0 ' Disable error trapping.    
	Exit Sub
End Sub

Sub OutCell (txt As String)
	Print #1, txt; vbTab;
End Sub

Sub FillClipboard
	StatusBarText = "Export Data To Clipboard..."
	' Load whole file to string variable    
	tempFile = DefaultFilePath & "\temp.txt"
	Open tempFile  For Input As #1
	L = LOF(1)
	AllData$ = Input$(L,1)
	Close #1
	'Copy whole data to clipboard
	Clipboard AllData$ 
	Kill tempFile
	StatusBarText = ""
End Sub

'************************
' Get Current Design Units
Private Function Unit_fncn() As String
	currUnit = ActiveDocument.unit
    If currUnit = 2 Then
      currunitName$ = "mil"
    ElseIf currUnit = 3 Then
      currunitName$ = "in."
    ElseIf currUnit = 4 Then
      currunitName$ = "mm"
    End If	
    Unit_fncn = currunitName
End Function
